<script setup>
// imports
import PageHeader from '@/components/base/PageHeader.vue'
import LoadingComponent from '@/components/base/LoadingComponent.vue'
import { useRoute } from 'vue-router'
import { useEditProductStore } from '@/core/stores/edit_product'
import ButtonComponent from '@/components/base/ButtonComponent.vue'
import { api, error_handler } from '@/core/services/api.service'
import { ref } from 'vue'
import { toast } from 'vue3-toastify'
import { useHead } from '@vueuse/head'

// route details
const { params } = useRoute()

// data
const editProduct = useEditProductStore()
const edittingPost = ref(false)
await editProduct.getProduct(params.id)

// methods
const productFormSubmitHandler = async (values) => {
  edittingPost.value = true
  api
    .put(`products/${params.id}`, {
      title: values.title,
      price: values.price,
      discountPercentage: values.discountPercentage,
      rating: values.rating,
      stock: values.stock,
      brand: values.brand,
      category: values.category,
      description: values.description
    })
    .then((res) => {
      if (res.status === 200) {
        toast('Product has been updated', { type: 'success' })
      }
    })
    .catch((error) => {
      error_handler(error)
    })
    .finally(() => {
      edittingPost.value = false
    })
}

  //head
  useHead({
  title: 'Dolphino challenge | ' + editProduct?.product?.title,
  meta: [
    {
      name: `description`,
      content: editProduct?.product?.description
    },
    {
      name: 'keywords',
      content: 'shop,product,mobile,laptop,tablet'
    },
    {
      meta: 'og:title',
      content: 'Dolphino challenge | ' + editProduct?.product?.title
    },
    {
      meta: 'og:site_name',
      content: 'Dolphino challenge'
    },
    {
      meta: 'url',
      content: 'https://test.com'
    },
    {
      meta: 'og:description',
      content: editProduct?.product?.description
    },
    {
      meta: 'og:type',
      content: 'website'
    },
    {
      meta: 'og:image',
      contetn: 'https://address-of-site-logo.com'
    }
  ]
})
</script>
<template>
  <!--loading-->
  <LoadingComponent :loading="editProduct.loading || edittingPost" />

  <!--page header-->
  <PageHeader title="Edit Product" :description="'Edit product with id ' + params.id" />

  <!--product form-->
  <vee-form
    v-if="!editProduct?.loading"
    @submit="productFormSubmitHandler"
    class="mt-10 flex flex-col gap-4"
    v-slot="{ errors }"
  >
    <!--title-->
    <div>
      <label class="form-label">Title <span>*</span></label>
      <vee-field
        name="title"
        :value="editProduct.product.title"
        type="text"
        :class="!!errors.title && '!border-rose-400'"
        class="form-input"
        rules="required|min:5"
        placeholder="Enter product title"
      />
      <vee-error-message name="title" class="form-error" />
    </div>
    <div class="grid grid-cols-1 sm:grid-cols-3 gap-4">
      <!--price-->
      <div>
        <label class="form-label">Price <span>*</span></label>
        <vee-field
          name="price"
          :value="editProduct.product.price"
          type="text"
          :class="!!errors.price && '!border-rose-400'"
          class="form-input"
          rules="required"
          placeholder="Enter Product's price"
        />
        <vee-error-message name="price" class="form-error" />
      </div>

      <!--discountPercentage-->
      <div>
        <label class="form-label">Discount</label>
        <vee-field
          name="discountPercentage"
          :value="editProduct.product.discountPercentage"
          type="text"
          :class="!!errors.discountPercentage && '!border-rose-400'"
          class="form-input"
          placeholder="Enter Product discount"
        />
        <vee-error-message name="discountPercentage" class="form-error" />
      </div>

      <!--rating-->
      <div>
        <label class="form-label">Rating</label>
        <vee-field
          name="rating"
          :value="editProduct.product.rating"
          type="text"
          :class="!!errors.rating && '!border-rose-400'"
          class="form-input"
          placeholder="Enter product rate"
        />
        <vee-error-message name="rating" class="form-error" />
      </div>

      <!--stock-->
      <div>
        <label class="form-label">Stock <span>*</span></label>
        <vee-field
          name="stock"
          :value="editProduct.product.stock"
          type="text"
          :class="!!errors.stock && '!border-rose-400'"
          class="form-input"
          rules="required|numeric"
          placeholder="Enter product stock"
        />
        <vee-error-message name="stock" class="form-error" />
      </div>

      <!--brand-->
      <div>
        <label class="form-label">Brand <span>*</span></label>
        <vee-field
          name="brand"
          :value="editProduct.product.brand"
          type="text"
          :class="!!errors.brand && '!border-rose-400'"
          class="form-input"
          rules="required"
          placeholder="Enter product brand"
        />
        <vee-error-message name="brand" class="form-error" />
      </div>

      <!--category-->
      <div>
        <label class="form-label">Category <span>*</span></label>
        <vee-field
          name="category"
          :value="editProduct.product.category"
          type="text"
          :class="!!errors.category && '!border-rose-400'"
          class="form-input"
          rules="required"
          placeholder="Enter product category"
        />
        <vee-error-message name="category" class="form-error" />
      </div>
    </div>

    <!--description-->
    <div>
      <label class="form-label">Descrition <span>*</span></label>
      <vee-field
        name="description"
        :value="editProduct.product.description"
        type="text"
        as="textarea"
        cols="30"
        rows="10"
        :class="!!errors.description && '!border-rose-400'"
        class="form-input"
        rules="required|min:45"
        placeholder="Enter your Message"
      />
      <vee-error-message name="description" class="form-error" />
    </div>

    <ButtonComponent type="submit" title="Submit" class="!ml-auto !block w-full sm:w-fit">
      Submit
    </ButtonComponent>
  </vee-form>
</template>
<style scoped></style>
